app/main/forms.py
from wtforms import StringField, SelectField, BooleanField, TextAreaField, SubmitField
from wtforms.validators import Required, Length, ValidationError
from flask_wtf import RecaptchaField, FlaskForm
from ..models import User, Role

validation_error_msgs = {
    'username_used' : 'username already used',
    'user_not_exist' : 'no user exist with this username',
    'email_used' : 'email is already registered'
}

class UserProfileEditForm(FlaskForm):
    username = StringField('username', validators=[Required(), Length(1, 32)])
    about_me = TextAreaField('about_me', validators=[Length(0, 300)])
    recaptcha = RecaptchaField()
    submit = SubmitField('submit')

    def __init__(self, user, *args, **kwargs):
        super().__init__(*args, **kwargs)
        self.user = user

    def validate_username(self, field):
        if self.user.username != field.data and \
                     User.query.filter(User.username == field.data).first():
            raise ValidationError(validation_error_msgs['username_used'])

class AccountsControlForm(FlaskForm):
    username = StringField('username', validators=[Required()])
    recaptcha = RecaptchaField()
    submit = SubmitField('submit')

    def validate_username(self, field):
        if not User.query.filter(User.username == field.data).first():
            raise ValidationError(validation_error_msgs['user_not_exist'])

class UserAccountControlForm(FlaskForm):
    """used by admin users to control other accounts"""
    email = StringField('email address', validators=[Required(), Length(1, 64)])
    account_confirmation = BooleanField('account_confirmation')
    user_role = SelectField('user_role', coerce=int)
    recaptcha = RecaptchaField()
    submit = SubmitField('submit')
    
    def __init__(self, user, *args, **kwargs):
        super().__init__(*args, **kwargs)
        self.user_role.choices = [(role.id, role.role_name) for role in Role.query.all()]
        self.user = user
    
    def validate_email(self, field):
        if self.user.email != field.data and \
                     User.query.filter(User.email == field.data).first():
            raise ValidationError(validation_error_msgs['email_used'])

class UserAskQuestion(FlaskForm):
    question = TextAreaField('question', validators=[Required(), Length(1, 500)])
    recaptcha = RecaptchaField()
    submit = SubmitField('submit')

class UserAnswerQuestion(FlaskForm):
    answer = TextAreaField('answer', validators=[Required(), Length(1, 500)])
    recaptcha = RecaptchaField()
    submit = SubmitField('submit')

app/main/__init__.py
from flask import Blueprint


main = Blueprint('main', __name__)

from . import views, errors

app/main/views.py
import random
from werkzeug.exceptions import NotFound
from itsdangerous import TimedJSONWebSignatureSerializer, BadSignature
from flask import render_template, abort, redirect, url_for, current_app, flash
from flask_login import login_required, current_user
from confg import TokenExpirationTime
from app import app_database
from app.models import User, AppPermissions, Role, Question
from ..decorators import permissions_required
from .forms import UserProfileEditForm, UserAccountControlForm, AccountsControlForm, \
                   UserAskQuestion, UserAnswerQuestion
from . import main

@main.app_context_processor
def templates_add_app_permissions():
    return dict(app_permissions=AppPermissions)

@main.route('/')
@login_required
def home():
    questions_list = []
    for user in current_user.get_followed_users_list():
        for question in user.get_answered_questions(questions_limit=5):
            questions_list.append(question)
    random.shuffle(questions_list)
    return render_template('main/home.html', questions_list=questions_list)

@main.route('/u/<username>')
@login_required
def user_profile(username):
    user = User.load_user_by_username(username)
    if not user:
        abort(NotFound.code)
    return render_template('main/user/user_profile.html', 
                           user=user, answered_questions=user.get_answered_questions(),
                           unanswered_questions=user.get_unanswered_questions())

@main.route('/u/<username>/ask-question', methods=['GET', 'POST'])
@login_required
@permissions_required(AppPermissions.ASK)
def user_ask_question(username):
    user = User.load_user_by_username(username)
    if not user:
        abort(NotFound.code)
    if current_user.username == username:
        return redirect(url_for('main.home'))
    ask_question_form = UserAskQuestion()
    if ask_question_form.validate_on_submit():
        current_user.ask_question(question_content=ask_question_form.question.data,
                                  question_recipient=user)
        flash('your question was sent successfully', category='info')
        return redirect(url_for('main.home'))
    return render_template('main/user/ask-question-form.html', form=ask_question_form, user=user)

@main.route('/u/<username>/answer/<int:question_id>', methods=['GET', 'POST'])
@login_required
def user_answer_question(username, question_id):
    question = Question.load_question_by_id_or_404(question_id)
    if current_user.username != username \
                    or not current_user.is_question_replier(question) \
                    or question.has_answer:
        return redirect(url_for('main.home'))
    answer_question_form = UserAnswerQuestion()
    if answer_question_form.validate_on_submit():
        current_user.answer_question(answer_content=answer_question_form.answer.data,
                                     question=question)
        return redirect(url_for('main.user_profile', username=current_user.username))
    return render_template('main/user/answer-question-form.html', form=answer_question_form)

@main.route('/u/<username>/edit-profile', methods=['GET', 'POST'])
@login_required
def user_profile_edit(username):
    if current_user.username != username:
        abort(NotFound.code)
    form = UserProfileEditForm(current_user._get_current_object())
    if form.validate_on_submit():
        current_user.username = form.username.data
        current_user.about_me = form.about_me.data
        app_database.session.add(current_user._get_current_object())
        return redirect(url_for('main.user_profile', username=current_user.username))
    form.username.data = current_user.username
    form.about_me.data = current_user.about_me
    return render_template('main/user/user_profile_edit.html', form=form)

@main.route('/accounts-control', methods=['GET', 'POST'])
@login_required
@permissions_required(AppPermissions.ADMINISTER)
def accounts_control():
    form = AccountsControlForm()
    if form.validate_on_submit():
        token_gen = TimedJSONWebSignatureSerializer(current_app.config['SECRET_KEY'], 
                                                    expires_in=TokenExpirationTime.AFTER_5_MIN)
        token_payload = {'username': form.username.data}
        token = token_gen.dumps(token_payload)
        return redirect(url_for('main.user_account_control', 
                                username=form.username.data, token=token))
    return render_template('main/user/accounts_control.html', form=form)

@main.route('/u/account-control/<token>/<username>', methods=['GET', 'POST'])
@login_required
@permissions_required(AppPermissions.ADMINISTER)
def user_account_control(token, username):
    token_verify = TimedJSONWebSignatureSerializer(current_app.config['SECRET_KEY'])
    try:
        token_verify.loads(token)
    except BadSignature:
        abort(NotFound.code)
    user = User.load_user_by_username(username)
    if not user:
        abort(NotFound.code)
    form = UserAccountControlForm(user)
    if form.validate_on_submit():
        user.email = form.email.data
        user.account_confirmed = form.account_confirmation.data
        user.role = Role.load_role_by_id(form.user_role.data)
        app_database.session.add(user)
        return redirect(url_for('main.user_profile', username=current_user.username))
    form.email.data = user.email
    form.account_confirmation.data = user.account_confirmed
    form.user_role.data = user.role_id
    return render_template('main/user/user_account_control_admin.html', form=form)

@main.route('/u/<username>/follow')
@login_required
@permissions_required(AppPermissions.FOLLOW_OTHERS)
def follow_user(username):
    user = User.load_user_by_username(username)
    if not user:
        abort(NotFound.code)
    if current_user.username == username or current_user.is_following(user):
        return redirect(url_for('main.home'))
    current_user.follow(user)
    return redirect(url_for('main.user_profile', username=user.username))

@main.route('/u/<username>/unfollow')
@login_required
@permissions_required(AppPermissions.FOLLOW_OTHERS)
def unfollow_user(username):
    user = User.load_user_by_username(username)
    if not user:
        abort(NotFound.code)
    if current_user.username == username or not current_user.is_following(user):
        return redirect(url_for('main.home'))
    current_user.unfollow(user)
    return redirect(url_for('main.user_profile', username=user.username))

app/templates/main/user/accounts_control.html
{% extends 'base.html' %}
{% import 'macros/get_flashed_messages.html' as flashed_messages %}

{% block title %}
&#123; AMA &#125; - Accounts Control
{% endblock %}

{% block page_content %}
<div class="container text-center">
    {{ flashed_messages.get_flashed_info_messages(class='alert alert-info alert-dismissible fade show alert-msg-box-fixed') }}
    {{ flashed_messages.get_flashed_error_messages(class='alert alert-danger alert-dismissible fade show alert-msg-box-fixed') }}
    
    <form style="padding-top: 130px" method="POST" action="">
        <h1>&#123; AMA &#125;</h1>
        <h3 style="margin-bottom: 20px;">Please Sign In</h3>
        {{ form.csrf_token }}
        <div class="row">
            {{ form.username(class='form-control offset-md-4 col-md-4', placeholder='username') }}
            <div class="col-md-4 text-left" style="padding-top:18px;">
                <span style="color: #ff0000; font-size: 18px;">
                {% for error in form.username.errors %}
                    {{ error }}
                {% endfor %}
                </span>
            </div>
        </div>
        <div class="row">
        {{ form.submit(class='btn btn-lg btn-primary offset-md-4 col-md-4', type='submit', style='margin-top: 30px') }}
        </div>
        <div class="row" style="margin-top: 15px;">
            <div class="col-md-4 offset-md-4">
            {{ form.recaptcha }}
            </div>
            <div class="col-md-4 text-left" style="padding-top:18px;">
                <span style="color: #ff0000; font-size: 18px;">
                {% for error in form.recaptcha.errors %}
                    {{ error }}
                {% endfor %}
                </span>
            </div>
        </div>
    </form>

    <p style="padding-top: 10px">
        <a href="{{ url_for('auth.signup') }}">bak to home</a>
    </p>
</div>
{% endblock %}

{% block unit_test %}
{% if config['TESTING'] %}
<input type="hidden" value="testing-accounts-control-AMA">
{% endif %}
{% endblock %}

app/templates/main/user/answer-question-form.html
{% extends 'base.html' %}
{% import 'macros/get_flashed_messages.html' as flashed_messages %}

{% block title %}
&#123; AMA &#125; -  Answer Question
{% endblock %}

{% block page_content %}
<div class="container text-center">
    <form style="padding-top: 130px" method="POST" action="">
        <h1>&#123; AMA &#125;</h1>
        <h3 style="margin-bottom: 20px;">Answer The Question</h3>
        {{ form.csrf_token }}
        <div class="row">
            {{ form.answer(class='form-control col-md-4 offset-md-4', style="height:200px;") }}
            <div class="col-md-4 text-left" style="padding-top:18px;">
                <span style="color: #ff0000; font-size: 18px;">
                    {% for error in form.answer.errors %}
                        {{ error }}
                    {% endfor %}
                </span>
            </div>
        </div>
        <div class="row">
        {{ form.submit(class='btn btn-lg btn-primary offset-md-4 col-md-4', type='submit', style='margin-top: 30px') }}
        </div>
        <div class="row" style="margin-top: 15px;">
            <div class="col-md-4 offset-md-4">
            {{ form.recaptcha }}
            </div>
            <div class="col-md-4 text-left" style="padding-top:18px;">
                <span style="color: #ff0000; font-size: 18px;">
                {% for error in form.recaptcha.errors %}
                    {{ error }}
                {% endfor %}
                </span>
            </div>
        </div>
    </form>

    <p style="padding-top: 10px">
        <a href="{{ url_for('main.home') }}">back to home</a>
    </p>
</div>
{% endblock %}

{% block unit_test %}
{% if config['TESTING'] %}
<input type="hidden" value="testing-answer-question-form-AMA">
{% endif %}
{% endblock %}

app/templates/main/user/ask-question-form.html
{% extends 'base.html' %}
{% import 'macros/get_flashed_messages.html' as flashed_messages %}

{% block title %}
&#123; AMA &#125; -  Ask Question
{% endblock %}

{% block page_content %}
<div class="container text-center">
    <form style="padding-top: 130px" method="POST" action="">
        <h1>&#123; AMA &#125;</h1>
        <h3 style="margin-bottom: 20px;">Ask {{ user.username }}</h3>
        {{ form.csrf_token }}
        <div class="row">
            {{ form.question(class='form-control col-md-4 offset-md-4', style="height:200px;") }}
            <div class="col-md-4 text-left" style="padding-top:18px;">
                <span style="color: #ff0000; font-size: 18px;">
                    {% for error in form.question.errors %}
                        {{ error }}
                    {% endfor %}
                </span>
            </div>
        </div>
        <div class="row">
        {{ form.submit(class='btn btn-lg btn-primary offset-md-4 col-md-4', type='submit', style='margin-top: 30px') }}
        </div>
        <div class="row" style="margin-top: 15px;">
            <div class="col-md-4 offset-md-4">
            {{ form.recaptcha }}
            </div>
            <div class="col-md-4 text-left" style="padding-top:18px;">
                <span style="color: #ff0000; font-size: 18px;">
                {% for error in form.recaptcha.errors %}
                    {{ error }}
                {% endfor %}
                </span>
            </div>
        </div>
    </form>

    <p style="padding-top: 10px">
        <a href="{{ url_for('main.home') }}">back to home</a>
    </p>
</div>
{% endblock %}

{% block unit_test %}
{% if config['TESTING'] %}
<input type="hidden" value="testing-ask-question-form-AMA">
{% endif %}
{% endblock %}

app/templates/main/user/user_account_control_admin.html
{% extends 'base.html' %}
{% import 'macros/get_flashed_messages.html' as flashed_messages %}

{% block title %}
&#123; AMA &#125; - account control ( Admin )
{% endblock %}

{% block page_content %}
<div class="container text-center">
    {{ flashed_messages.get_flashed_info_messages(class='alert alert-info alert-dismissible fade show alert-msg-box-fixed') }}
    {{ flashed_messages.get_flashed_error_messages(class='alert alert-danger alert-dismissible fade show alert-msg-box-fixed') }}
    
    <form style="padding-top: 130px" method="POST" action="">
        <h1>&#123; AMA &#125;</h1>
        <h3 style="margin-bottom: 20px;">Account Control</h3>
        {{ form.csrf_token }}
        <div class="row">
            {{ form.email(class='form-control offset-md-4 col-md-4', placeholder='email') }}
            <div class="col-md-4 text-left" style="padding-top:18px;">
                <span style="color: #ff0000; font-size: 18px;">
                {% for error in form.email.errors %}
                    {{ error }}
                {% endfor %}
                </span>
            </div>
        </div>
        <div class="row">
            {{ form.user_role(class='custom-select form-control col-md-4 offset-md-4') }}
        </div>
        <div class="row">
            <div class="form-check offset-md-4" style="margin-top: 20px">
                {{ form.account_confirmation(class='form-check-input', type='checkbox', id='account-confirm') }}
                <label class="form-check-label" for="account-confirm">
                    confirm account
                </label>
            </div>
        </div>
        <div class="row">
        {{ form.submit(class='btn btn-lg btn-primary offset-md-4 col-md-4', type='submit', style='margin-top: 30px') }}
        </div>
        <div class="row" style="margin-top: 15px;">
            <div class="col-md-4 offset-md-4">
            {{ form.recaptcha }}
            </div>
            <div class="col-md-4 text-left" style="padding-top:18px;">
                <span style="color: #ff0000; font-size: 18px;">
                {% for error in form.recaptcha.errors %}
                    {{ error }}
                {% endfor %}
                </span>
            </div>
        </div>
    </form>

    <p style="padding-top: 10px">
        <a href="{{ url_for('main.home') }}">back to home</a>
    </p>
</div>
{% endblock %}

{% block unit_test %}
{% if config['TESTING'] %}
<input type="hidden" value="testing-user-account-control-AMA">
{% endif %}
{% endblock %}

app/templates/main/user/user_profile.html
{% extends 'base.html' %}


{% block title %}
&#123; AMA &#125; - {{ user.username }} Profile
{% endblock %}

{% block stylesheet %}
{{ super() }}
<link rel="stylesheet" href="/static/home_profiles.css">
{% endblock %}


{% block page_content %}    
    {{ super() }}

    <div class="container page-content">
        <div class="text-center" style="width:100%; padding-top:15px;">
            <img src="{{ user.generate_gravatar_uri(200) }}" class="rounded-circle mx-auto d-block img-thumbnail">
            <h3 style="margin-top:5px;">{{ user.username }}</h3>
        </div>
        <hr style="margin-top:15px; width:90%;">
        <div class="text-center" style="padding: 5px 60px;">
        {{ user.about_me }}
        </div>
        {% if current_user.username != user.username %}
        <hr style="width:20%">
        <div class="text-center">
            <a class="btn btn-primary" href="{{ url_for('main.user_ask_question', username=user.username) }}">
                Ask
            </a>
            {% if current_user.is_following(user) %}
                <a class="btn btn-primary" href="{{ url_for('main.unfollow_user', username=user.username) }}">
                    Unfollow
                </a>
            {% else %}
                <a class="btn btn-primary" href="{{ url_for('main.follow_user', username=user.username) }}">
                    Follow
                </a>
            {% endif %}
            </a>
        </div>
        {% endif %}
        {% if current_user.is_followed_by(user) %}
        <hr style="width: 10%">
        <div class="text-center">
            <span class="badge badge-primary badge-pill">
                Follows You
            </span>
        </div>
        {% endif %}
        <div>
            <ul class="nav nav-tabs" id="questions-tabs" style="margin-bottom:20px;">
                <li class="nav-item">
                    <a class="nav-link active" id="answered-questions-tab" data-toggle="tab" href="#answered-questions">
                      Answered Questions
                    </a>
                </li>
                {% if current_user.username == user.username %}
                {% if unanswered_questions %}
                <li class="nav-item">
                    <a class="nav-link" id="unanswered-questions-tab" data-toggle="tab" href="#unanswered-questions">
                        <span class="badge badge-primary badge-pill">{{ unanswered_questions|length }}</span>
                        Unanswered Questions
                    </a>
                </li>
                {% endif %}
                {% endif %}
                {% if user.get_followed_users_list() %}
                <li class="nav-item">
                    <a class="nav-link" id="following-tab" data-toggle="tab" href="#following">
                        <span class="badge badge-primary badge-pill">
                            {{ user.get_followed_users_list()|length }}
                        </span>
                        Following
                    </a>
                </li>
                {% endif %}
                {% if user.get_followers_list() %}
                <li class="nav-item">
                    <a class="nav-link" id="followers-tab" data-toggle="tab" href="#followers">
                        <span class="badge badge-primary badge-pill">
                            {{ user.get_followers_list()|length }}
                        </span>
                        Followers
                    </a>
                </li>
                {% endif %}
            </ul>
            <div class="tab-content" id="questions-tabs-content">
                <div class="tab-pane fade show active" id="answered-questions">
                    {% for question in answered_questions %}
                    <div>
                        <a href="{{ url_for('main.user_profile', username=question.asker.username)}}">
                            <img class="img-thumbnail" src="{{ question.asker.generate_gravatar_uri(18) }}">
                            {{ question.asker.username }}
                        </a>
                    </div>
                    <div>
                        <p style="font-weight:bold;margin-bottom:8px;">Q: {{ question.question_content }}</p>
                        <p>{{ question.answer.answer_content }}</p>
                    </div>
                    <hr style="width: 50%;">
                    {% endfor %}
                </div>
                {% if current_user.username == user.username %}
                {% if unanswered_questions %}                
                <div class="tab-pane fade" id="unanswered-questions">
                    {% for question in unanswered_questions %}
                    <div>
                        <a href="{{ url_for('main.user_profile', username=question.asker.username)}}">
                            <img class="img-thumbnail" src="{{ question.asker.generate_gravatar_uri(18) }}">
                            {{ question.asker.username }}
                        </a>
                    </div>
                    <div class="d-flex justify-content-between">
                        <p style="font-weight:bold;" class="">Q: {{ question.question_content }}</p>
                        <a href="{{ url_for('main.user_answer_question', username=current_user.username, question_id=question.id) }}">
                            Answer
                        </a>
                    </div>
                    <hr style="width: 50%;">
                    {% endfor %}
                </div>
                {% endif %}
                {% endif %}
                {% if user.get_followed_users_list() %}
                <div class="tab-pane fade" id="following">
                    {% for followed_user in user.get_followed_users_list() %}
                    <div>
                        <a href="{{ url_for('main.user_profile', username=followed_user.username) }}">
                            <img class="img-thumbnail" src="{{ followed_user.generate_gravatar_uri(30) }}">
                            <span style="font-weight:bold;">
                                {{ followed_user.username }}
                            </span>
                        </a>
                    </div>
                    {% endfor %}
                </div>
                {% endif %}
                {% if user.get_followers_list() %}
                <div class="tab-pane fade" id="followers">
                    {% for follower in user.get_followers_list() %}
                    <div>
                        <a href="{{ url_for('main.user_profile', username=follower.username) }}">
                            <img class="img-thumbnail" src="{{ follower.generate_gravatar_uri(30) }}">
                            <span style="font-weight:bold;">
                                {{ follower.username }}
                            </span>
                        </a>
                    </div>
                    {% endfor %}
                </div>
                {% endif %}
            </div>

        </div>
    </div>
{% endblock %}


{% block unit_test %}
{% if config['TESTING'] %}
<input type="hidden" value="testing-user-profile-AMA">
{% endif %}
{% endblock %}

app/templates/main/user/user_profile_edit.html
{% extends 'base.html' %}
{% import 'macros/get_flashed_messages.html' as flashed_messages %}

{% block title %}
&#123; AMA &#125; - Profile Edit
{% endblock %}

{% block page_content %}
<div class="container text-center">
    {{ flashed_messages.get_flashed_info_messages(class='alert alert-info alert-dismissible fade show alert-msg-box-fixed') }}
    {{ flashed_messages.get_flashed_error_messages(class='alert alert-danger alert-dismissible fade show alert-msg-box-fixed') }}
    
    <form style="padding-top: 130px" method="POST" action="">
        <h1>&#123; AMA &#125;</h1>
        <h3 style="margin-bottom: 20px;">Edit Profile</h3>
        {{ form.csrf_token }}
        <div class="row">
        {{ form.username(class='form-control offset-md-4 col-md-4', placeholder='username') }}
        <div class="col-md-4 text-left" style="padding-top:18px;">
            <span style="color: #ff0000; font-size: 18px;">
            {% for error in form.username.errors %}
                {{ error }}
            {% endfor %}
            </span>
        </div>
        </div>
        <div class="row">
        {{ form.about_me(class='form-control offset-md-4 col-md-4', type='password', placeholder='bio') }}
        </div>
        <div class="row">
        {{ form.submit(class='btn btn-lg btn-primary offset-md-4 col-md-4', type='submit', style='margin-top: 30px') }}
        </div>
        <div class="row" style="margin-top: 15px;">
            <div class="col-md-4 offset-md-4">
            {{ form.recaptcha }}
            </div>
            <div class="col-md-4 text-left" style="padding-top:18px;">
                <span style="color: #ff0000; font-size: 18px;">
                {% for error in form.recaptcha.errors %}
                    {{ error }}
                {% endfor %}
                </span>
            </div>
        </div>
    </form>

    <p style="padding-top: 10px">
        <a href="{{ url_for('main.home') }}">back to home</a>
    </p>
</div>
{% endblock %}

{% block unit_test %}
{% if config['TESTING'] %}
<input type="hidden" value="testing-user-profile-edit-AMA">
{% endif %}
{% endblock %}